Index: /trunk/expressoMail1_2/js/main.js
===================================================================
--- /trunk/expressoMail1_2/js/main.js	(revision 1005)
+++ /trunk/expressoMail1_2/js/main.js	(revision 1035)
@@ -23,4 +23,11 @@
 			write_msg(get_lang("Attention, you are in out of office mode."), true);
 		ConstructMenuTools();
+
+        // Insere a applet de criptografia
+        if (preferences.use_signature_digital_cripto == '1'){
+            loadApplet();
+        }
+        // Fim da inserção da applet
+
 		cExecute ("$this.imap_functions.get_folders_list", update_menu);
 	}
@@ -36,9 +43,85 @@
 	// Get cyrus delimiter
 	cyrus_delimiter = Element('cyrus_delimiter').value;
-	
+    var del_return = function(data){
+		//alert(data);
+	}
+
+	cExecute ("$this.imap_functions.delete_mailbox&del_past=INBOX/decifradas", del_return);
 	cExecute ("$this.db_functions.get_dropdown_contacts", save_contacts);
 	cExecute ("$this.functions.get_preferences", save_preferences);
 	setTimeout('auto_refresh()', time_refresh);
 }
+
+/**
+ * Carrega a applet java no objeto search_div
+ * @author Mário César Kolling <mario.kolling@serpro.gov.br>
+ */
+
+function loadApplet(){
+
+    var search_div = Element('search_div');
+    var applet = null;
+    if (navigator.userAgent.match('MSIE')){
+        applet = document.createElement('<object style="display:yes;width:0;height:0;vertical-align:bottom;" id="cert_applet" ' +
+            'classid="clsid:8AD9C840-044E-11D1-B3E9-00805F499D93"></object>');
+
+        //applet = document.createElement('object');
+        //var attributes = {
+        //    style:'display:yes;width:0;height:0;vertical-align:bottom;',
+        //    id:'cert_applet',
+        //    classid:'clsid:8AD9C840-044E-11D1-B3E9-00805F499D93'
+        //}
+
+        var parameters = {
+            type:'application/x-java-applet;version=1.5',
+            code:'ExpressoSmimeApplet',
+            codebase:'../',
+            mayscript:'true',
+            token: token_param,
+            locale: locale,
+            archive:'ExpressoCertMail.jar,' +
+                'ExpressoCert.jar,' +
+                'bcmail-jdk15-142.jar,' +
+                'mail.jar,' +
+                'activation.jar,' +
+                'bcprov-jdk15-142.jar,' +
+                'commons-codec-1.3.jar,' +
+                'commons-httpclient-3.1.jar,' +
+                'commons-logging-1.1.1.jar'
+            //debug:'true'
+        }
+
+        //for (var attribute in attributes){
+        //    applet.setAttribute(attribute, attributes[attribute]);
+        //}
+
+        if (parameters != 'undefined' && parameters != null){
+            for (var parameter in parameters) {
+                var param = document.createElement("PARAM");
+                param.setAttribute("name",parameter);
+                param.setAttribute("value",parameters[parameter]);
+                applet.appendChild(param);
+            }
+        }
+        search_div.appendChild(applet);
+        //alert(search_div.innerHTML);
+        //alert(window.);
+    }
+    else {
+        applet = document.createElement('embed');
+        applet.innerHTML = '<embed style="display:yes;width:0;height:0;vertical-align:bottom;" id="cert_applet" code="ExpressoSmimeApplet.class" ' +
+            'codebase="../" locale="'+locale+'"'+
+            'archive="ExpressoCertMail.jar,ExpressoCert.jar,bcmail-jdk15-142.jar,mail.jar,activation.jar,bcprov-jdk15-142.jar,commons-codec-1.3.jar,commons-httpclient-3.1.jar,commons-logging-1.1.1.jar" ' +
+            'token="' + token_param + '" ' +
+            'type="application/x-java-applet;version=1.5" mayscript > ' +
+            //'type="application/x-java-applet;version=1.5" debug="true" mayscript > ' +
+            '<noembed> ' +
+            'No Java Support. ' +
+            '</noembed> ' +
+            '</embed> ';
+        search_div.appendChild(applet);
+    }
+}
+
 function disable_field(field,condition) {
 	var comando = "if ("+condition+") { document.getElementById('"+field.id+"').disabled=true;} else { document.getElementById('"+field.id+"').disabled=false; }";
@@ -137,4 +220,39 @@
 			write_msg(get_lang("Error in SMTP sending read confirmation."));
 	}
+    
+	if(msg_info.source)
+	{
+        // Abrindo um e-mail criptografado
+        // Verifica se existe o objeto applet
+        if (!Element('cert_applet')){
+            // se não existir, mostra mensagem de erro.
+            write_msg(get_lang('The preference "%1" isn\'t enabled.', get_lang('Enable digitally sign/cipher the message?')));
+        } else {
+            // se existir prepara os dados para serem enviados e chama a
+            // operação na applet
+
+            connector.showProgressBar();
+
+           // if ((msg_info.DispositionNotificationTo) && ((msg_info.Unseen == 'U') || (msg_info.Recent == 'N'))){
+            /*	var confNotification = confirm(get_lang("The sender waits your notification of reading. Do you want to confirm this?"), "");
+                if (confNotification)*/
+            //        cExecute ("$this.imap_functions.send_notification&notificationto="+msg_info.DispositionNotificationTo+"&subject="+url_encode(msg_info.subject), handler_sendNotification);
+           // }
+
+            Element('cert_applet').doButtonClickAction('decript',
+                                                        msg_info.msg_number,
+                                                        msg_info.source,
+                                                        msg_info.msg_folder); // Passa os dados para a applet
+        }
+		return;
+
+	}
+
+
+	if (msg_info.status_get_msg_info == 'false')
+	{
+		write_msg(get_lang("Problems reading your message")+ ".");
+		return;
+	}
 
 	if (msg_info.status == 'false'){
@@ -142,8 +260,10 @@
 	}
 	else{
+        var ID = msg_info.original_ID ? msg_info.original_ID : msg_info.msg_number;
+        var id_msg_read = ID+"_r";
+
 		if (preferences.use_shortcuts == '1')
-			select_msg(msg_info.msg_number, 'null');
+			select_msg(ID, 'null');
 		// Call function to draw message
-		var id_msg_read = msg_info.msg_number +"_r";
 		// If needed, delete old border
 		if (openTab.type[currentTab] == 2 || openTab.type[currentTab] == 3)
@@ -173,8 +293,10 @@
 
 		var domains = "";
-		if ((msg_info.DispositionNotificationTo) && (!msg_is_read(msg_info.msg_number) || (msg_info.Recent == 'N')))
+		if ((msg_info.DispositionNotificationTo) && (!msg_is_read(ID) || (msg_info.Recent == 'N')))
 		{			
 			if (preferences.notification_domains != undefined && preferences.notification_domains != "")
+            {
 				domains = preferences.notification_domains.split(',');
+            }
 			else
 			{				
@@ -194,11 +316,12 @@
 		}
 		//Change msg class to read.
-		if (!msg_is_read(msg_info.msg_number))
+		if (!msg_is_read(ID))
 		{
-			set_msg_as_read(msg_info['msg_number'], true);
-			if (msg_info.cacheHit)
-				set_message_flag(msg_info.msg_number, "seen"); // avoid caducous (lazy) data
-		}
-
+            set_msg_as_read(ID, true);
+			if (msg_info.cacheHit || (!proxy_mensagens.is_local_folder(get_current_folder()) && msg_info.original_ID))
+            {
+				set_message_flag(ID, "seen"); // avoid caducous (lazy) data
+            }
+        }
 	}
 }
@@ -1214,4 +1337,46 @@
 
 function send_message_return(data, ID){
+
+    var sign = false;
+	var crypt = false;
+
+    if ((preferences.use_assinar_criptografar != '0') && (preferences.use_signature_digital_cripto != '0')){
+		var checkSign = document.getElementById('return_digital_'+ID)
+		if (checkSign.checked){
+			sign = true;
+		}
+
+		var checkCript = document.getElementById('return_cripto_'+ID);
+		if (checkCript.checked){
+			crypt = true;
+		}
+	}
+
+    if (typeof(data) == 'object' && !data.success)
+	{
+        connector = new  cConnector();
+        connector.showProgressBar();
+
+        if (sign || crypt){
+            var operation = '';
+			if (sign){
+				operation = 'sign';
+			}
+			else { // crypt
+                //TODO: Colocar mensagem de erro, e finalizar o método.
+				operation = 'nop';
+			}
+        }
+
+        if (data.body){
+            Element('cert_applet').doButtonClickAction(operation, ID, data.body);
+        }
+        else {
+			alert(data.error);
+		}
+
+		return;
+    }
+
 	if(data && data.success == true ){
 		// if send ok, set a flag as answered or forwarded
@@ -1252,4 +1417,60 @@
 			write_msg(get_lang("Connection failed with %1 Server. Try later.", "Web"));
 	}
+}
+
+function appletReturn(smime, ID, operation, folder){
+	//alert('os dados chegaram!');
+    //alert("ID: " + ID + "\n" + smime);
+	if(operation=='decript')
+	{
+		var handler = function(data){
+
+			if(data.msg_day == '')
+			{
+                header=expresso_local_messages.get_msg_date(data.original_ID, proxy_mensagens.is_local_folder(get_current_folder()));
+
+				data.fulldate=header.fulldate;
+				data.smalldate=header.smalldate;
+				data.msg_day = header.msg_day;
+				data.msg_hour = header.msg_hour;
+
+			}
+			this.show_msg(data);
+		}
+		para="&source="+smime+"&ID="+ID+"&folder="+folder;
+		cExecute ("$this.imap_functions.show_decript&", handler, para);
+	}else
+	{
+        ID_tmp = ID;
+        // Lê a variável e chama a nova função cExecuteForm
+        // Processa e envia para o servidor web
+        // Faz o request do connector novamente. Talvez implementar no connector
+        // para manter coerência.
+
+        var handler_send_smime = function(data){
+            send_message_return(data, this.ID_tmp); // this is a hack to escape quotation form connector bug
+        };
+
+        var textArea = document.createElement("TEXTAREA");
+        textArea.style.display='none';
+        textArea.name = "smime";
+        textArea.value += smime;
+
+        // Lê a variável e chama a nova função cExecuteForm
+        // Processa e envia para o servidor web
+        // Faz o request do connector novamente. Talvez implementar no connector
+        // para manter coerência.
+        if (is_ie){
+            var i = 0;
+            while (document.forms(i).name != "form_message_"+ID){i++}
+            form = document.forms(i);
+        }
+        else
+            form = document.forms["form_message_"+ID];
+
+        form.appendChild(textArea);
+
+        cExecuteForm ("$this.imap_functions.send_mail", form, handler_send_smime, ID);
+    }
 }
 
Index: /trunk/expressoMail1_2/js/draw_api.js
===================================================================
--- /trunk/expressoMail1_2/js/draw_api.js	(revision 1000)
+++ /trunk/expressoMail1_2/js/draw_api.js	(revision 1035)
@@ -514,7 +514,7 @@
 		
 		td_element2 = document.createElement("TD");
-		td_element2.setAttribute("width", "2%");		
+		td_element2.setAttribute("width", "7%");
 		td_element3 = document.createElement("TD");
-		td_element3.setAttribute("width", "31%");
+		td_element3.setAttribute("width", "29%");
 		td_element3.onclick = function () {sort_box(search_box_type,'SORTFROM');};
 		td_element3.id = "message_header_SORTFROM_"+numBox;
@@ -523,5 +523,5 @@
 		
 		td_element4 = document.createElement("TD");
-		td_element4.setAttribute("width", "41%");
+		td_element4.setAttribute("width", "38%");
 		td_element4.onclick = function () {sort_box(search_box_type,'SORTSUBJECT');};
 		td_element4.id = "message_header_SORTSUBJECT_"+numBox;
@@ -752,9 +752,20 @@
 		td_element21.id = "td_message_answered_"+headers_msgs.msg_number;
 
+		if (headers_msgs.attachment && headers_msgs.attachment.number_attachments > 0) {
+			attach_name = headers_msgs.attachment.names.split(", ");
+			for(var item in attach_name)
+			{
+				if (url_decode(attach_name[item]) != 'smime.p7s' && url_decode(attach_name[item]) != 'smime.p7m'){
+					td_element21.innerHTML = "<img src ='templates/"+template+"/images/clip.gif' title='" + url_decode(attach_name[item]) + "'>";
+					break;
+				}
+			}
+		}
+
 		if ((headers_msgs.Forwarded == 'F')  || (headers_msgs.Draft == 'X' && headers_msgs.Answered == 'A')){
 			td_element21.innerHTML = "<img src ='templates/"+template+"/images/forwarded.gif' title='"+get_lang('Forwarded')+"'>";
 			headers_msgs.Draft = '' 
 			headers_msgs.Answered = '';
-			headers_msgs.Forwarded == 'F';
+			headers_msgs.Forwarded = 'F';
 		}
 		else if (headers_msgs.Draft == 'X')
@@ -768,18 +779,44 @@
 		td_element22.className = "td_msg";
 		td_element22.setAttribute("width", "1%");
-		td_element22.id = "td_message_important_"+headers_msgs.msg_number;
+		td_element22.id = "td_message_signed_"+headers_msgs.msg_number;
+
+        //td_element23 = document.createElement("TD");
+		//td_element23.setAttribute("width", "1%");
+		//td_element23.id = "td_message_signed_"+headers_msgs.msg_number;
+        switch(headers_msgs.ContentType)
+		{
+            case "signature":
+			{
+				td_element22.innerHTML = "<img src ='templates/"+template+"/images/signed_msg.gif' title='" + get_lang('Signed message') + "'>";
+				break;
+			}
+            case "cipher":
+			{
+				td_element22.innerHTML = "<img src ='templates/"+template+"/images/lock.gif' title='" + get_lang('Crypted message') + "'>";
+				break;
+			}
+            default:
+			{
+				break;
+			}
+		}
+
+        td_element23 = document.createElement("TD");
+		td_element23.className = "td_msg"
+		td_element23.setAttribute("width", "1%");
+		td_element23.id = "td_message_important_"+headers_msgs.msg_number;
 
 		if (headers_msgs.Flagged == 'F' || (headers_msgs.Importance.toLowerCase().indexOf("high") != -1 && preferences.use_important_flag == 'True'))
 		{
-			td_element22.innerHTML = "<img src ='templates/"+template+"/images/important.gif' title='"+get_lang('Important')+"'>";
+			td_element23.innerHTML = "<img src ='templates/"+template+"/images/important.gif' title='"+get_lang('Important')+"'>";
 		}
 		else
-			td_element22.innerHTML = "&nbsp;&nbsp;&nbsp;";
-
-		td_element23 = document.createElement("TD");
-		td_element23.className = "td_msg";
-		td_element23.setAttribute("width", "1%");
-		td_element23.id = "td_message_sent_"+headers_msgs.msg_number;
-		td_element23.innerHTML = "&nbsp;&nbsp;&nbsp;";
+			td_element23.innerHTML = "&nbsp;&nbsp;&nbsp;";
+
+		td_element24 = document.createElement("TD");
+		td_element24.className = "td_msg";
+		td_element24.setAttribute("width", "1%");
+		td_element24.id = "td_message_sent_"+headers_msgs.msg_number;
+		td_element24.innerHTML = "&nbsp;&nbsp;&nbsp;";
 		// preload image
 		var _img_sent = new Image();
@@ -803,5 +840,5 @@
 			else{				
 				if(headers_msgs.to.email.toLowerCase() != Element("user_email").value)
-					td_element23.innerHTML = "<img valign='center' src ='templates/"+template+"/images/sent.gif' title='"+get_lang('Sent')+"'>";
+					td_element24.innerHTML = "<img valign='center' src ='templates/"+template+"/images/sent.gif' title='"+get_lang('Sent')+"'>";
 			
 				if ((headers_msgs.to)&&(headers_msgs.to.name != null))
@@ -880,4 +917,5 @@
 		tr_element.appendChild(td_element22);
 		tr_element.appendChild(td_element23);
+        tr_element.appendChild(td_element24);
 		tr_element.appendChild(td_element3);
 		tr_element.appendChild(td_element4);
@@ -966,30 +1004,50 @@
 	// Old
 	//img_next_msg.onclick = function () {cExecute ("$this.imap_functions.get_info_next_msg&msg_number="+ info_msg.msg_number + "&msg_folder="+ info_msg.msg_folder + "&sort_box_type="+ sort_box_type +  "&search_box_type="+ search_box_type +"&sort_box_reverse="+ sort_box_reverse +"&reuse_border="+ID, show_msg)};
-	var folder = document.getElementById(ID.substr(0, ID.indexOf('_')));
+    var folder_id = 0;
+    folder_id = info_msg.original_ID ? info_msg.original_ID: info_msg.msg_number;
+	var folder = document.getElementById(folder_id);
 	if (!folder){
 		delete_border(ID);
 		return;
 		}
-	if (folder.nextSibling){
-		var nextMsgBox = folder.nextSibling.name?folder.nextSibling.name:info_msg.msg_folder;
-		img_next_msg.onclick = function()
+    if (folder){ // mensagem local criptografada nao tem ID da pasta local
+        if (folder.nextSibling){
+            var nextMsgBox = folder.nextSibling.name?folder.nextSibling.name:info_msg.msg_folder;
+
+            if (nextMsgBox == "INBOX/decifradas")// teste para ver se a mensagem vem da pasta oculta decifradas
+                    nextMsgBox = get_current_folder();
+
+            img_next_msg.onclick = function()
+            {
+                currentTab = ID;
+                openTab.type[ID] = 2;
+                            proxy_mensagens.get_msg(parseInt(folder.nextSibling.id),nextMsgBox,true,show_msg);
+                //cExecute("$this.imap_functions.get_info_msg&msg_number="+folder.nextSibling.id+"&msg_folder="+nextMsgBox, show_msg);
+            };
+        }
+        else
+        {
+            img_next_msg.src = "./templates/"+template+"/images/down.gray.button.png";
+            img_next_msg.style.cursor = 'default';
+
+        }
+    }
+    else
+    {
+        img_next_msg.src = "./templates/"+template+"/images/down.gray.button.png";
+		img_next_msg.style.cursor = 'default';
+		if (!proxy_mensagens.is_local_folder(get_current_folder()) && !(info_msg.msg_folder == "INBOX/decifradas")) // testa se a mensagem e local
 		{
-			currentTab = ID;
-			openTab.type[ID] = 2;
-                        proxy_mensagens.get_msg(parseInt(folder.nextSibling.id),nextMsgBox,true,show_msg);
-			//cExecute("$this.imap_functions.get_info_msg&msg_number="+folder.nextSibling.id+"&msg_folder="+nextMsgBox, show_msg);
-		};
-	}
-	else
-		img_next_msg.onclick = function()
-			{
-				/*current_page++;
-				msg_range_end = (current_page*preferences.max_email_per_page);
-				msg_range_begin = (msg_range_end-(preferences.max_email_per_page)+1);
-				kill_current_box();
-				cExecute ('$this.imap_functions.get_range_msgs2&folder='+current_folder+'&msg_range_begin='+msg_range_begin+'&msg_range_end='+msg_range_end+'&sort_box_reverse=1', function handler(data){draw_box(data, current_folder);}) */
-					delete_border(ID);
-			};
-
+            img_next_msg.onclick = function()
+                {
+                    /*current_page++;
+                    msg_range_end = (current_page*preferences.max_email_per_page);
+                    msg_range_begin = (msg_range_end-(preferences.max_email_per_page)+1);
+                    kill_current_box();
+                    cExecute ('$this.imap_functions.get_range_msgs2&folder='+current_folder+'&msg_range_begin='+msg_range_begin+'&msg_range_end='+msg_range_end+'&sort_box_reverse=1', function handler(data){draw_box(data, current_folder);}) */
+                        delete_border(ID);
+                };
+        }
+    }
 	var img_space = document.createElement("SPAN");
 	img_space.innerHTML = "&nbsp;";
@@ -1002,26 +1060,43 @@
 	//Old
 	//img_previous_msg.onclick = function () {cExecute ("$this.imap_functions.get_info_previous_msg&msgs_number="+ info_msg.msg_number + "&folder="+ info_msg.msg_folder + "&sort_box_type="+ sort_box_type+ "&search_box_type="+ search_box_type + "&sort_box_reverse="+ sort_box_reverse +"&reuse_border="+ID, show_msg)}
-	folder = document.getElementById(ID.substr(0, ID.indexOf('_')));
+	//folder = document.getElementById(ID.substr(0, ID.indexOf('_')));
 	if (!folder){
 	        delete_border(ID);
 		return;
 		}
-	if (folder.previousSibling)
+    if (folder){ // mensagem local criptografada nao tem ID da pasta local
+        if (folder.previousSibling)
+        {
+            var previousMsgBox = folder.previousSibling.name?folder.previousSibling.name:info_msg.msg_folder;
+
+            if (previousMsgBox == "INBOX/decifradas") // teste para ver se a mensagem vem da pasta oculta decifradas
+                    previousMsgBox = get_current_folder();
+
+            img_previous_msg.onclick = function()
+            {
+                currentTab = ID;
+                openTab.type[ID] = 2;
+                //cExecute("$this.imap_functions.get_info_msg&msg_number="+folder.previousSibling.id+"&msg_folder=" + previousMsgBox, show_msg);
+                            proxy_mensagens.get_msg(parseInt(folder.previousSibling.id),previousMsgBox,true,show_msg);
+            };
+        }
+        else
+        {
+            img_previous_msg.src = "./templates/"+template+"/images/up.gray.button.png";
+            img_previous_msg.style.cursor = 'default';
+        }
+	}
+	else
 	{
-		var previousMsgBox = folder.previousSibling.name?folder.previousSibling.name:info_msg.msg_folder;
-		img_previous_msg.onclick = function()
-		{
-			currentTab = ID;
-			openTab.type[ID] = 2;
-			//cExecute("$this.imap_functions.get_info_msg&msg_number="+folder.previousSibling.id+"&msg_folder=" + previousMsgBox, show_msg);
-                        proxy_mensagens.get_msg(parseInt(folder.previousSibling.id),previousMsgBox,true,show_msg);
-		};
-	}
-	else
-		img_previous_msg.onclick = function()
-		{
-			delete_border(ID);
-		};
-
+		img_previous_msg.src = "./templates/"+template+"/images/up.gray.button.png";
+		img_previous_msg.style.cursor = 'default';
+		if (!proxy_mensagens.is_local_folder(get_current_folder()) && !(info_msg.msg_folder == "INBOX/decifradas")) // testa se a mensagem e local
+        {
+            img_previous_msg.onclick = function()
+            {
+                delete_border(ID);
+            };
+        }
+    }
 	next_previous_msg_td.appendChild(img_previous_msg);
 	next_previous_msg_td.appendChild(img_space);
@@ -1107,7 +1182,7 @@
 	option_mark.align = "left";
 	option_mark.width = "50%";
-	var option_mark_as_unseen = '<span class="message_options" onclick="set_messages_flag(\'unseen\','+info_msg.msg_number+');write_msg(\''+get_lang('Message marked as ')+get_lang("Unseen")+'.\');">'+get_lang("Unseen")+'</span>, ';
-	var option_mark_as_important = '<span class="message_options" onclick="set_messages_flag(\'flagged\','+info_msg.msg_number+');write_msg(\''+get_lang('Message marked as ')+get_lang("Important")+'.\');">'+get_lang("Important")+'</span>, ';
-	var option_mark_as_normal = '<span class="message_options" onclick="set_messages_flag(\'unflagged\','+info_msg.msg_number+');write_msg(\''+get_lang('Message marked as ')+get_lang("Normal")+'.\');">'+get_lang("Normal")+'</span>';
+	var option_mark_as_unseen = '<span class="message_options" onclick="set_messages_flag(\'unseen\','+folder_id+');write_msg(\''+get_lang('Message marked as ')+get_lang("Unseen")+'.\');">'+get_lang("Unseen")+'</span>, ';
+	var option_mark_as_important = '<span class="message_options" onclick="set_messages_flag(\'flagged\','+folder_id+');write_msg(\''+get_lang('Message marked as ')+get_lang("Important")+'.\');">'+get_lang("Important")+'</span>, ';
+	var option_mark_as_normal = '<span class="message_options" onclick="set_messages_flag(\'unflagged\','+folder_id+');write_msg(\''+get_lang('Message marked as ')+get_lang("Normal")+'.\');">'+get_lang("Normal")+'</span>';
 	option_mark.innerHTML = option_mark_as_unseen+option_mark_as_important+option_mark_as_normal;
 	option_hide_more.innerHTML = get_lang('Options');
@@ -1192,4 +1267,60 @@
 	tbody_message_options.appendChild(tr_other_options);
 	////////// END OTHER OPTIONS ////////////////
+
+    	////////// BEGIN SIGNATURE //////////////////
+	if (info_msg.signature && info_msg.signature.length > 0)
+	{
+		var tr_signature = document.createElement("TR");
+		var td_signature = document.createElement("TD");
+		td_signature.className = 'tr_message_header';
+		tr_signature.id = 'tr_signature_'+ID;
+		td_signature.colSpan = "5";
+		tr_signature.style.display = 'none';
+
+		for (i in info_msg.signature)
+			td_signature.innerHTML += '<span>'+info_msg.signature[i]+'</span> <br /> ';
+		var signature_status_pos = info_msg.signature[0].indexOf(get_lang('Message untouched'));
+		td_signature.id = "td_signature_"+ID;
+		if(signature_status_pos < 0 )
+		{
+		td.innerHTML += '&nbsp;<img style="cursor:pointer" src="templates/'+template+'/images/signed_error.gif" title="'+get_lang("Details")+'">';
+		tr_signature.style.display = '';
+		}
+		else
+		{
+		td.innerHTML += '&nbsp;<img style="cursor:pointer" src="templates/'+template+'/images/signed_table.gif" title="'+get_lang("Details")+'">';
+		}
+		td.onclick = function(){
+		var _height = Element("div_message_scroll_"+ID).style.height;
+		_height = parseInt(_height.replace("px",""));
+		var _offset = 130;
+		if (this.value == 'more_cert'){
+			//this.innerHTML += "<b><u>Mais Informaï¿œï¿œes</u></b>";
+			this.value = 'hide_cert';
+			Element("div_message_scroll_"+ID).style.height = (_height + _offset)+"px";
+			Element('tr_signature_'+ID).style.display = 'none';
+			Element('td_signature_'+ID).style.display = 'none';
+
+		}
+		else{
+			//this.innerHTML += "Mais Informaï¿œï¿œes";
+			this.value = 'more_cert';
+			Element("div_message_scroll_"+ID).style.height = (_height - _offset)+"px";
+			Element('tr_signature_'+ID).style.display = '';
+			Element('td_signature_'+ID).style.display = '';
+		}
+	};
+
+		tr_signature.appendChild(td_signature);
+		tbody_message_options.appendChild(tr_signature);
+	/******************************************* Old signature   ***********************************************/
+		//if (info_msg.signature != "void")
+		//	td.innerHTML += '&nbsp;<img style="cursor:pointer" onclick="alert(\''+ get_lang("This message is signed, and you can trust.") + info_msg.signature +'\');" src="'+tpl_img_path+'/signed.gif">';
+		//else
+		//	td.innerHTML += "&nbsp;<img style='cursor:pointer' onclick='alert(\""+get_lang("This message is signed, but it is invalid. You should not trust on it.")+"\");' title='"+get_lang("Voided message")+"' src='"+tpl_img_path+"/invalid.gif'>";
+	/*****************************************															********/
+	}
+	//////////// END SIGNATURE ////////////////
+
 	table_message_options.appendChild(tbody_message_options);
 	td0.appendChild(table_message_options);
@@ -2072,5 +2203,50 @@
 	input_return_receipt.name = "input_return_receipt";
 	input_return_receipt.setAttribute("tabIndex","-1");
-	td_return_receipt.appendChild(input_return_receipt);	
+	td_return_receipt.appendChild(input_return_receipt);
+
+
+//alert("preferences.use_assinar_criptografar " + preferences.use_assinar_criptografar);
+//alert("preferences.use_signature_digital_cripto " + preferences.use_signature_digital_cripto);
+//alert("preferences.use_signature_digital " + preferences.use_signature_digital);
+//alert("preferences.use_signature_cripto " + preferences.use_signature_cripto);
+
+    if(preferences.use_assinar_criptografar==1)
+	{
+		if(preferences.use_signature_digital_cripto==1)
+		{
+			td_return_receipt.innerHTML +=  "&nbsp;&nbsp;" + get_lang("Digitally sign message?")+"";
+			var input_return_digital = document.createElement('input');
+			input_return_digital.type = "checkbox";
+			input_return_digital.className = "checkbox";
+			input_return_digital.id = "return_digital_"+ID;
+			input_return_digital.name = "input_return_digital";
+			input_return_digital.setAttribute("tabIndex","-1");
+			if(preferences.use_signature_digital==1)
+			{
+				input_return_digital.defaultChecked=true;
+			}
+			td_return_receipt.appendChild(input_return_digital);
+                        //descomentariar a linha abaixo para criptografia
+			td_return_receipt.innerHTML +=  "&nbsp;&nbsp;" + get_lang("Digitally crypt message?")+"";
+			var input_return_cripto = document.createElement('input');
+			input_return_cripto.type = "checkbox";
+			input_return_cripto.className = "checkbox";
+			input_return_cripto.id = "return_cripto_"+ID;
+			input_return_cripto.name = "input_return_cripto";
+			input_return_cripto.setAttribute("tabIndex","-1");
+			//input_return_cripto.style.display = "none";
+			input_return_cripto.defaultChecked=false;
+			//Descomentariar o bloco abaixo para criptografia
+
+			if(preferences.use_signature_cripto==1)
+			{
+				input_return_cripto.defaultChecked=true;
+			}
+
+			td_return_receipt.appendChild(input_return_cripto);
+
+		}
+	}
+
 	tr5.appendChild(td5);
 	tr5.appendChild(td_return_receipt);
